let requestPromise = require('request-promise-native');
const Global = require('./global');


async function navigateWebsite(idHotel, checkin, checkout, adultos, criancas) {

    try {

        let options = {
            uri: Global.CRAWLER_ENDPOINT + '/omnibees',
            qs: {
                idHotel: idHotel,
                checkin: checkin,
                checkout: checkout,
                adultos: adultos,
                criancas: criancas
            },
            json: true // Automatically parses the JSON string in the response
        };

        let response = await requestPromise.get(options);

        return Promise.resolve(response);

    } catch (err) {
        console.log("caiu aqui no erro");
        console.error(err.error);
        return Promise.reject(err.error);
    }
}


async function getSuggestionDates(idHotel, checkin, checkout, adultos, criancas) {

    try {

        let options = {
            uri: Global.CRAWLER_ENDPOINT + '/omnibees/suggestion',
            qs: {
                idHotel: idHotel,
                checkin: checkin,
                checkout: checkout,
                adultos: adultos,
                criancas: criancas
            },
            json: true // Automatically parses the JSON string in the response
        };

        let response = await requestPromise.get(options);

        return Promise.resolve(response);

    } catch (err) {
        console.log("caiu aqui no erro");
        console.error(err.error);
        return Promise.reject(err.error);
    }
}


// //

// https://myreservations.omnibees.com/default.aspx?q=5307&diff=false&CheckIn=25022018&CheckOut=26022018&Code=&group_code=&loyality_card=&NRooms=1&ad=2&ch=0&ag=-
// https://myreservations.omnibees.com/default.aspx?q=5307&diff=false&CheckIn=25022018&CheckOut=26022018&Code=&group_code=&loyality_card=&NRooms=1&ad=2&ch=0&ag=-

// //
// navigateWebsite(3687, '14072018', '17072018', 2, 1).then(data => {
//     console.log("sucesso")
// }).catch(error => {
//     console.log("caiu aqui");
//     console.log(error.message);
// });


// navigateWebsite(1798, '10052018', '11052018', 2, 0).then(data => {
//     console.log(data);
//     console.log("sucesso")
//
// }).catch(error => {
//     console.log("caiu aqui");
//     console.log(error.message);
// });


module.exports = {search: navigateWebsite, getSuggestionDates: getSuggestionDates};



